/*	Exec.c	for arper4	*/
/*	1998/09/07	Rick	*/

#include	<corlib.h>
#include	<direct.h>
#include	"arper.h"
#include	<HS_wlib.h>

extern int	uncomp( arpbox* );
extern int	popupmenu( arpbox*, WindowID, EventInfo* );
extern int	lamp( arpbox*, WindowID, EventInfo* );
extern store	**jump( arpbox*, store** );
extern store	**parentsearch( arpbox* );
extern int	markclr( arpbox* );
extern void	newarp( char*, WindowID );
extern int	USO( WindowID, EventInfo*, int, void* );
int	ExecA( WindowID, EventInfo* );
int	ExecB( WindowID, EventInfo* );
int	makeStrings( arpbox* );

extern	char	client[32][88], nbuf[88];
extern	int	arpnum;
static	char	*sendptr[MAXENTRY];

static	short	Clip1[] = {	0xFFDF, 0xFFDF, 0xC1DF, 0xDEDF, 0xD75F, 0xD75F,
				0xD75F, 0xD75F, 0xD0DF, 0xFFDF, 0x801F, 0xFFFF
			},
		Clip2[] = {	0xFFC0, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
				0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x0000
			},
		Paper1[] = {	0xFFDF, 0xFFDF, 0xC1DF, 0xDCDF, 0xDD5F, 0xDC5F, 
				0xDF5F, 0xDF5F, 0xC05F, 0xFFDF, 0x801F, 0xFFFF
			},
		Paper2[] = {	0xFFC0, 0x8000, 0x8000, 0x9C00, 0x9D00, 0x9C00,
				0x9F00, 0x9F00, 0x8000, 0x8000, 0x8000, 0x0000
			};
static Sheet	ClipPattern = { 12, 12, 1, Clip1, Clip2 },
		PaperPattern = { 12, 12, 1, Paper1, Paper2 };


int
ExecA( wp, info )
WindowID	wp;
EventInfo	*info;
{
	arpbox	*cl;
	DrawBuf	dbuf[3];
	int	i;
	unsigned int	m;
	store	**putptr;
	cl= HS_WindowGetClientPointer( wp );
	switch( info->option ){
		case EventOpen:
			return TRUE;
		case EventRedraw:
			DrawSetClear( dbuf, 1 );
			DrawSetSymbol( dbuf+1, 2, 0, cl->arcfile, 9, 12 );
			DrawSetSymbol( dbuf+2, 2, 12, &((cl->parptr)->name[cl->baselen]), 9, 12 );
			WindowDraw( wp, dbuf, 3 );
			if( cl->Bwp )
				WindowRedraw( cl->Bwp );
			return TRUE;
		case EventClose:
			putptr= cl->endptr;
			for( i=1; i < cl->count; i++ ){
				if( (**--putptr).data[0] == '<' ){
					rmdir( *putptr );
				}else{	if( ( (**putptr).flag & 4 ) == 4 ){
				 		remove( *putptr );
					}
				}
			}
			rmdir( cl->base );
			if( cl->Bwp ){
				WindowClose( cl->Bwp );
				cl->Bwp= 0;
			}
			WindowClose( wp );
			free( cl->stptr );
			free( cl->filptr );
			client[cl->clno][0]= '\0';
			free( cl );
			--arpnum;
			return TRUE;
		case EventResize:
			cl->h= info->h;
			if( cl->h>326 )	cl->h= 326;
			cl->v= info->v;
			WindowResize( wp, info->x, info->y, cl->h, cl->v );
			m= cl->nowct * 12;
			if( m > cl->v - 30 ){
				WindowClose( cl->Bwp ); 
				cl->Bwp= WindowScrollOpen( 0, 24, cl->h, cl->v - 24,
							cl->Awp, 326, m, DirectionX|DirectionY, 16, 12, ExecB );
				WindowSetEventAttr( cl->Bwp, EventAttrDefault );
				WindowSetClientData( cl->Bwp, NULL, cl );
			}else	WindowResize( cl->Bwp, 0, 24, cl->h, cl->v - 24 );
			WindowRedraw( wp );
			return TRUE;
		case EventMouseSwitch:
			if( info->x >= HS_WindowGetViewSizeX(wp) - 10
					&& info->y >= HS_WindowGetViewSizeY(wp) - 10 ){
				if( info->LeftON )
					WindowResizeOperation( wp, info );
				else
					return	FALSE;
			}else if( info->y > 24 ){
				info->y-= 24;
				WindowSendEvent( cl->Bwp, info );
				return TRUE;
			}else if( info->LeftON && cl->parent > 1 ){
				cl->parent= (cl->parptr)->no;
				cl->parptr= *parentsearch( cl );
				cl->nowct= (cl->parptr)->data[6];
				cl->nowptr= jump( cl, cl->filptr );
				m= cl->nowct * 12;
				if( m < cl->v - 30 )	m= cl->v - 30;
				WindowClose( cl->Bwp ); 
				cl->Bwp= WindowScrollOpen( 0, 24, cl->h, cl->v - 24, cl->Awp,
								326, m, DirectionX|DirectionY, 16, 12, ExecB );
				WindowSetEventAttr( cl->Bwp, EventAttrDefault );
				WindowSetClientData( cl->Bwp, NULL, cl );
				DrawSetLine( dbuf, 2, 12, HS_WindowGetViewSizeX( wp ), 23, 1, OptionFill );
				DrawSetSymbol( dbuf+1, 2, 12, &((cl->parptr)->name[cl->baselen]), 9, 12 );
				WindowDraw( cl->Awp, dbuf, 2 );
				WindowRedraw( cl->Bwp );
			}
			return TRUE;
		case EventUser:
			switch( info->ComData ){
			case UserPaste:
			case UserString:
				PathGetFullName2( nbuf, info->ComBuffer );
				newarp( nbuf, wp );
				return TRUE;
			case UserStrings:
				PathGetFullName2( nbuf, *(char**)info->ComBuffer );
				newarp( nbuf, wp );
				return TRUE;
		}
		return TRUE;
	}
	return FALSE;
}

int
ExecB( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[769], *dp= dbuf;
	int	a, i, j= 0, t;
	store	**putptr;
	arpbox	*cl;

	cl= HS_WindowGetClientPointer( HS_WindowGetParent( wp ) );
	putptr= cl->nowptr;
	switch( info->option ){
	case EventOpen:
		return	TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		for( i= 0; i < cl->nowct; i++ ){
			a= (**putptr).flag;
			if( (**putptr).data[0] == '<' ){
				DrawSetPut( dp++, 0, j, &ClipPattern );
			}else {
				DrawSetPut( dp++, 0, j, &PaperPattern );
			}
			DrawSetSymbol( dp++, 12, j, (**putptr).fname, a, 12 );
			DrawSetSymbol( dp++, 156, j, (**putptr).data, a, 12 );
			putptr++;
			j+= 12;
		}
		WindowDraw( wp, dbuf, dp-dbuf );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		cl->Bwp= 0;
		return	TRUE;
	case EventResize:
		WindowResize( wp, 0, 24, info->h, info->v-24 );
		WindowRedraw( wp );
		return TRUE;
	case EventMouseSwitch:
		cl->cury= info->y / 12;
		cl->nowfil= *(cl->nowptr + cl->cury);
		if( cl->cury >= cl->nowct ){
			cl->cury= -1;
		}
		if( cl->cury > -1 && info->LeftON ){
			if( info->x < 12 ){
				lamp( cl, wp, info );
				return	TRUE;
			}
			(cl->nowfil)->flag ^= 8;
			DrawSetSymbol( dp++, 12, cl->cury * 12, (cl->nowfil)->fname,
							(cl->nowfil)->flag, 12 );
			WindowDraw( wp, dbuf, dp-dbuf );
			if( ( (cl->nowfil)->flag & 4 ) == 4 ){
				if( makeStrings( cl ) ){
					if( USO( cl->Awp, info, UserStrings, &sendptr[0] )){
						markclr( cl );
						WindowRedraw( wp );
					}
				}
			}else {
				cl->st= ONTIME();
				cl->hflag= TRUE;
			}
			return TRUE;
		}
		if( cl->cury> -1 && info->LeftStat && cl->hflag ){
			t= ONTIME();
			if( t- cl->st >30 ){
				a= (cl->nowfil)->flag;
				(cl->nowfil)->flag &= 247;
				uncomp( cl );
				cl->hflag= FALSE;
				(cl->nowfil)->flag = a | 4;
				WindowRedraw( wp );
				if( makeStrings( cl ) ){
					if( USO( cl->Awp, info, UserStrings, &sendptr[0] )){
						markclr( cl );
						WindowRedraw( wp );
					}
				}
				return TRUE;
			}
		}
		if( info->LeftOFF){
			cl->hflag= FALSE;
			return FALSE;
		}
		if( info->RightON ){
			popupmenu( cl, wp, info );
			return TRUE;
		}
		return	FALSE;
	}
	return	FALSE;
}

int
makeStrings( cl )
arpbox	*cl;
{
	int	i, max= 0;
	store	**iptr= cl->nowptr;

	for( i=0; i < cl->nowct; i++){
		if( ( (**iptr).flag & 8 ) == 0 )
			sendptr[max++]= *iptr;
		iptr++;
	}
	sendptr[max]= NULL;
	
	return max;
}
