#include	<stdio.h>
#include	<string.h>

int listzip(char *nam, char *inf, FILE *fp)
{
	unsigned char	buf[30];
	unsigned int csize, uncsize;
	unsigned short	tim, dat, namelength, extralength;
	int t_year, t_month, t_day, t_hour, t_minute, t_second;

	if( fread( buf, sizeof( unsigned char ), 30, fp ) < 30 )
		return 0;
	if ( buf[0] != 'P' || buf[1] != 'K' || buf[2] != 3 || buf[3] != 4 )
		return 0;
	tim= ( buf[11] << 8 ) + buf[10];
	dat= ( buf[13] << 8 ) + buf[12];
	csize= ( buf[21] << 24 ) + ( buf[20] << 16 )
				+ ( buf[19] << 8 ) + buf[18];
	uncsize= ( buf[25] << 24 ) + ( buf[24] << 16 )
				+ ( buf[23] << 8 ) + buf[22];
	namelength= ( buf[27] << 8 ) + buf[26];
	extralength= ( buf[29] << 8 ) + buf[28];
	if( fread(nam, sizeof( char ), namelength, fp) < namelength )
		return -1;
	t_second = tim & 31;
	tim >>= 5;
	t_minute = tim & 63;
	tim >>= 6;
	t_hour = tim & 31;
	t_day = dat & 31;
	dat >>= 5;
	t_month = dat & 15;
	dat >>= 4;
	t_year = dat & 127;
	t_second *= 2;
	t_year= ( t_year + 80 ) & 99;
	nam[namelength] = 0;
	if( strlen( nam ) > 82 )	nam[82]= 0;
	sprintf( inf, "%8d %2d/%02d/%02d %02d:%02d:%02d",
			uncsize, t_year, t_month, t_day, t_hour, t_minute, t_second );
	if (fseek(fp, csize + extralength, 1) < 0)
		return -1;

	return 1;
}
